<template>
  <!-- Type create -->
  <div
    v-if="type === CardInterviewTargetTypes.create"
    class="w-full rounded-[12px] border border-borderColor border-opacity-100 flex flex-col gap-4"
    :class="size === ComponentSizes.compact ? 'p-6' : 'justify-center items-center p-8'"
  >
    <div class="flex flex-col gap-2">
      <div
        class="flex items-center gap-2"
        :class="
          size === ComponentSizes.compact ? '' : 'justify-center items-center'
        "
      >
        <div>
          <Icon
            icon="mingcute:target-line"
            :height="size === ComponentSizes.compact ? '20' : '24'"
            :width="size === ComponentSizes.compact ? '20' : '24'"
            class="text-primary"
          />
        </div>

        <svn-pro-text
          v-if="size === ComponentSizes.compact"
          subtitle-large
          bold
        >
          {{ targetTitle }}
        </svn-pro-text>

        <svn-pro-title v-else-if="size === ComponentSizes.default" h6 bold>
          {{ targetTitle }}
        </svn-pro-title>
      </div>

      <svn-pro-text
        body-medium
        regular
        color="onSurfaceVariant"
        :class="size === ComponentSizes.compact ? 'text-start' : 'text-center'"
      >
        {{ targetDescription }}
      </svn-pro-text>
    </div>

    <svn-pro-button
      :text="buttonText"
      :variant="buttonVariant"
      :class="size === ComponentSizes.compact ? 'w-full' : 'w-fit'"
      :prepend-icon="createPrependIcon"
      @click="emit('click-action')"
    />
  </div>

  <!-- Type create proposal -->
  <div
    v-else-if="
      type === CardInterviewTargetTypes?.create_proposal ||
      type === CardInterviewTargetTypes?.update_show
    "
    class="w-full rounded-[12px] border border-borderColor border-opacity-100 flex flex-col gap-4 p-6"
  >
    <div class="flex flex-col gap-4">
      <div class="flex items-center gap-2">
        <div>
          <Icon
            icon="mingcute:target-line"
            :height="size === ComponentSizes.compact ? '20' : '24'"
            :width="size === ComponentSizes.compact ? '20' : '24'"
            class="text-primary"
          />
        </div>

        <svn-pro-text
          v-if="size === ComponentSizes.compact"
          subtitle-large
          bold
        >
          {{ targetTitle }}
        </svn-pro-text>

        <svn-pro-title v-else-if="size === ComponentSizes.default" h6 bold>
          {{ targetTitle }}
        </svn-pro-title>
      </div>

      <div class="flex flex-col gap-3">
        <!-- Status && Deadline -->
        <div class="flex justify-between">
          <svn-pro-info-tag
            tag-size="compact"
            :tag-style="tagStyle"
            :leading-item="tagLeadingItem"
            :tag-type="getTagType()"
            :text="targetTargetValue"
          />

          <svn-pro-info-tag
            tag-size="compact"
            tag-style="text"
            tag-type="info"
            leading-item="icon"
            icon="mingcute:calendar-month-line"
            :text="targetDeadline || noDeadlineText"
          />
        </div>

        <!-- Target description -->
        <svn-pro-text body-medium regular color="onSurfaceVariant">
          {{ targetDescription }}
        </svn-pro-text>
      </div>

      <!-- Divider -->
      <svn-pro-divider
        v-if="type === CardInterviewTargetTypes?.create_proposal"
        color="[#767680]"
        class="border-opacity-100"
      />

      <div
        v-if="type === CardInterviewTargetTypes?.create_proposal || type === CardInterviewTargetTypes?.update_show"
        class="flex flex-col gap-4"
      >
        <!-- Employee suggestion -->
        <div v-if="hasEmployeeSuggestion" class="flex flex-col gap-4">
          <div class="flex items-center">
            <svn-pro-text medium body-medium>
              {{ variableLabelOne }}
            </svn-pro-text>

            <svn-pro-tooltip :text="tooltipOneContent">
              <template #activator="{ props }">
                <v-icon
                  v-bind="props"
                  size="16"
                  icon="custom:mingcute:information-line"
                  class="cursor-pointer text-onSurfaceVariant"
                />
              </template>
            </svn-pro-tooltip>
          </div>

          <!-- Variable -->
          <slot name="employee-suggestion" />
        </div>

        <!-- Manager suggestion OR Cross suggestion -->
        <div v-if="hasManagerOrCrossedSuggestion" class="flex flex-col gap-4">
          <div class="flex items-center">
            <svn-pro-text medium body-medium>
              {{ variableLabelTwo }}
            </svn-pro-text>

            <svn-pro-tooltip :text="tooltipTwoContent">
              <template #activator="{ props }">
                <v-icon
                  v-bind="props"
                  size="16"
                  icon="custom:mingcute:information-line"
                  class="cursor-pointer text-onSurfaceVariant"
                />
              </template>
            </svn-pro-tooltip>
          </div>

          <!-- Variable -->
          <slot name="manager-cross-suggestion" />
        </div>

        <!-- Manager suggestion OR Cross suggestion AND SUBMITED AND NOT DRAFT -->
        <div v-if="hasManagerOrCrossedSuggestionAndSubmitted" class="flex flex-col gap-4">
          <div class="flex items-center">
            <svn-pro-text medium body-medium>
              {{ variableLabelThree }}
            </svn-pro-text>

            <svn-pro-tooltip :text="tooltipThreeContent">
              <template #activator="{ props }">
                <v-icon
                  v-bind="props"
                  size="16"
                  icon="custom:mingcute:information-line"
                  class="cursor-pointer text-onSurfaceVariant"
                />
              </template>
            </svn-pro-tooltip>
          </div>

          <!-- Variable -->
          <slot name="manager-cross-suggestion-submitted" />
        </div>

        <!-- Show inputs if the interview is not submitted -->
        <div v-if="interviewStatus !== InterviewCompletionStatuses.submitted" class="flex flex-col gap-4">
          <v-radio-group
            v-if="targetObjectiveIndicator?.indicator_type === TargetObjectiveIndicatorTypes.multi_choice"
            v-model="indicatorCurrentValue"
            hide-details
          >
            <div
              v-for="item of getMCQOptions(targetObjectiveIndicator?.options?.multi_choice_list)"
              class="flex items-center w-fit"
            >
              <svn-pro-radio-button
                :value="item"
                :id="`${targetObjectiveIndicator?.id}--${item}`"
                color="primary"
                @click="updateSnapshot('current_value', item)"
              />

              <label :for="`${targetObjectiveIndicator?.id}--${item}`" class="cursor-pointer">
                <svn-pro-text body-large>
                  {{ item }}
                </svn-pro-text>
              </label>
            </div>
          </v-radio-group>

          <v-radio-group
            v-else-if="targetObjectiveIndicator?.indicator_type === TargetObjectiveIndicatorTypes.boolean"
            v-model="indicatorCurrentValue"
            hide-details
          >
            <div
              v-for="item of targetBooleanValue"
              class="flex items-center w-fit"
            >
              <svn-pro-radio-button
                :value="item"
                :id="`${targetObjectiveIndicator?.id}--${item}`"
                color="primary"
                @click="updateSnapshot('current_value', item)"
              />

              <label :for="`${targetObjectiveIndicator?.id}--${item}`" class="cursor-pointer">
                <svn-pro-text body-large>
                  {{ item }}
                </svn-pro-text>
              </label>
            </div>
          </v-radio-group>

          <svn-pro-text-field
            v-if="(targetObjectiveIndicator?.indicator_type === TargetObjectiveIndicatorTypes.percentage ||
              targetObjectiveIndicator?.indicator_type === TargetObjectiveIndicatorTypes.numeric) && !interviewLocked"
            :label="answerLabel"
            variant="outlined"
            class="h-fit"
            type="number"
            :disabled="interviewLocked"
            v-model="indicatorCurrentValue"
            @update:model-value="updateSnapshot('current_value', $event)"
          />

          <svn-pro-text-area
            v-model="targetComments"
            variant="outlined"
            :rows="6"
            :max-rows="6"
            :label="commentLabel"
            :textarea="true"
            @update:model-value="updateSnapshot('comments', $event)"
          />
        </div>
      </div>
    </div>

    <div
      v-if="type === CardInterviewTargetTypes.create_proposal"
      class="flex gap-4"
      :class="size === ComponentSizes.compact ? 'flex-col' : 'flex-row'"
    >
      <!-- Target info -->
      <svn-pro-text body-medium regular class="flex-1" color="onSurfaceVariant">
        {{ infoText }}
      </svn-pro-text>

      <!-- Actions -->
      <div class="flex items-center gap-2">
        <svn-pro-button
          :text="buttonText"
          :disabled="actionDisabled"
          :variant="buttonVariant"
          :class="size === ComponentSizes.compact ? 'flex-1' : ''"
          :prepend-icon="createPrependIcon"
          @click="emit('click-action')"
        />

        <svn-pro-icon-button
          :variant="deleteButtonVariant"
          :disabled="deleteDisabled"
          color="onSurfaceVariant"
          :icon="deleteIcon"
          @click="emit('click-delete')"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import { ref, watch, onMounted, computed, } from "vue";
import SvnProText from "../styles/SvnProText.vue";
import SvnProTitle from "../styles/SvnProTitle.vue";
import SvnProInfoTag from "../chip/SvnProInfoTag.vue";
import SvnProButton from "../button/SvnProButton.vue";
import SvnProTextArea from "../input/SvnProTextArea.vue";
import SvnProTooltip from "../tooltip/SvnProTooltip.vue";
import SvnProDivider from "../divider/SvnProDivider.vue";
import SvnProTextField from "../input/SvnProTextField.vue";
import SvnProIconButton from "../button/SvnProIconButton.vue";
import SvnProRadioButton from "../input/SvnProRadioButton.vue";
import {
  ComponentSizes,
  CardInterviewTargetTypes,
  InterviewCompletionStatuses,
  TargetObjectiveIndicatorTypes,
  ButtonVariants,
  InfotagStyles,
} from "../../constants/types.js";

const props = defineProps({
  type: {
    type: String,
    default: "create",
  },
  size: {
    type: String,
    default: "compact",
  },
  comments: {
    type: String,
    default: "",
  },
  selectedValue: {
    type: undefined,
    default: ""
  },
  interviewLocked: {
    type: Boolean,
    default: false,
  },
  actionDisabled: {
    type: Boolean,
    default: false,
  },
  deleteDisabled: {
    type: Boolean,
    default: false,
  },
  answerLabel: {
    type: String,
    default: "Answer",
  },
  commentLabel: {
    type: String,
    default: "Comment",
  },
  isFinalUpdate: {
    type: Boolean,
    default: false,
  },
  interviewStatus: {
    type: String,
    default: "in_progress",
  },
  noDeadlineText: {
    type: String,
    default: "Invalid date",
  },
  createPrependIcon: {
    type: String,
    default: "custom:mingcute:add-line",
  },
  deleteIcon: {
    type: String,
    default: "custom:delete-2-line",
  },
  infoText: {
    type: String,
    default:
      "This target is still a draft. Complete all interviews of the set to create it.",
  },
  buttonText: {
    type: String,
    default: "Create new target",
  },
  buttonVariant: {
    type: String,
    default: "flat",
  },
  deleteButtonVariant: {
    type: String,
    default: "outlined",
  },
  currentUserId: {
    type: Number,
    default: null,
  },
  interviewKind: {
    type: String,
    default: "employee",
  },
  tagStyle: {
    type: String,
    default: "filled",
  },
  tagLeadingItem: {
    type: String,
    default: undefined,
  },
  targetTitle: {
    type: String,
    default: "New target",
  },
  targetDeadline: {
    type: String,
    default: "24 oct.",
  },
  targetDescription: {
    type: String,
    default:
      "Targets added will be create and add to Roadmap when the Cross Review will be submitted.",
  },
  targetTargetValue: {
    type: String,
    default: "",
  },
  targetObjectiveIndicator: {
    type: Object,
    default: () => {},
  },
  target: {
    type: Object,
    default: () => {},
  },
  tooltipOneContent: {
    type: String,
    default: "Content one",
  },
  tooltipTwoContent: {
    type: String,
    default: "Content two",
  },
  tooltipThreeContent: {
    type: String,
    default: "Content three",
  },
  variableLabelOne: {
    type: String,
    default: "Suggested updates",
  },
  variableLabelTwo: {
    type: String,
    default: "Your suggested update",
  },
  variableLabelThree: {
    type: String,
    default: "Final update",
  },
  hasEmployeeSuggestion: {
    type: Boolean,
    default: false,
  },
  hasManagerOrCrossedSuggestion: {
    type: Boolean,
    default: false,
  },
  hasManagerOrCrossedSuggestionAndSubmitted: {
    type: Boolean,
    default: false,
  },
});

onMounted(() => {
  targetComments.value = props?.comments;

  if (!props?.target?.current_suggestion && props?.interviewKind == 'crossed') {
    const previousSuggestion = props?.target?.suggestions?.find((suggestion) =>
      suggestion?.user?.id === props?.currentUserId && suggestion?.state === 'manager'
    );

    indicatorCurrentValue.value = previousSuggestion?.proposal;
    targetComments.value = previousSuggestion?.comment;
  } else {
    indicatorCurrentValue.value = props?.target?.current_suggestion?.proposal;
    targetComments.value = props?.target?.current_suggestion?.comment;
  }
});

const emit = defineEmits(["click-action", "click-delete", "update-snapshot"]);

const targetComments = ref(null);
const indicatorCurrentValue = ref(null);
const targetBooleanValue = computed (() => {
  if (props?.targetObjectiveIndicator?.indicator_type === 'boolean') {
    return [props?.targetObjectiveIndicator?.options?.starting_value, props?.targetObjectiveIndicator?.options?.target_value]
  } else {
    return []
  }
})

const getTagType = () => {
  switch (props?.targetObjectiveIndicator?.status) {
    case "completed":
      return "success";
    case "in_progress":
      return "warning";
    case "uncompleted":
      return "error";
    default:
      return "success";
  }
};

const getMCQOptions = (mcq) => {
  if (mcq) {
    return mcq.map((option) => {
      return option.option;
    });
  }
};

const updateSnapshot = async(type = 'current_value', value) => {
  if (type === 'current_value') {
    emit("update-snapshot", {
      current_value: value,
      comment: targetComments?.value,
    });
  } else if (type === 'comments') {
    emit("update-snapshot", {
      current_value: indicatorCurrentValue?.value,
      comment: value,
    });
  }
};

watch(props, (newValue, oldValue) => {
  if (newValue?.comments) {
    targetComments.value = newValue?.comments
  }
  if (newValue?.target) {
    if (!newValue?.target?.current_suggestion && newValue?.interviewKind == 'crossed') {
      const previousSuggestion = newValue?.target?.suggestions?.find((suggestion) =>
        suggestion?.user?.id === props?.currentUserId && suggestion?.state === 'manager'
      );

      indicatorCurrentValue.value = previousSuggestion?.proposal;
      targetComments.value = previousSuggestion?.comment;
    } else {
      indicatorCurrentValue.value = newValue?.target?.current_suggestion?.proposal;
      targetComments.value = newValue?.target?.current_suggestion?.comment;
    }
  }
}, { deep: true })
</script>